﻿/*
//================================================

Finance Toolbar
This show you the real time stock market information.
Copyright (C) 2012 Stefan vd - All Rights Reserved.
www.stefanvd.net

//================================================
*/

function $(id) { return document.getElementById(id); }
// settings
var marqueebehaviour = null, direction = null, scrollamount = null, japan = null, xminutes = null, excludedstock = null, favoritestock = null, favo1 = null, favo2 = null, favo3 = null, favo4 = null, getinfovaluestock = null, getinfovaluepercent = null, getinfovaluemc = null;

var esbTB_observe = function(subject, topic, data) {
   if (topic != "nsPref:changed") {
     return;
   }
window.location.reload(); // refresh page, so it can get the new settings value
}

var esbTB_init = function() {
  prefs =
    Components.classes["@mozilla.org/preferences-service;1"]
              .getService(Components.interfaces.nsIPrefService)
              .getBranch("extensions.FinanceToolbar.");
  prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
  prefs.addObserver("", esbTB_observe, false);
}

// Init addin after window loaded
window.addEventListener("load", esbTB_init, false);


/////////// Option page settings
document.addEventListener('DOMContentLoaded', function () {

// Firefox read pref
var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
marqueebehaviour = prefManager.getCharPref("extensions.FinanceToolbar.marqueebehaviour");
direction = prefManager.getCharPref("extensions.FinanceToolbar.direction");
scrollamount = prefManager.getCharPref("extensions.FinanceToolbar.scrollamount");
japan = prefManager.getBoolPref("extensions.FinanceToolbar.japan");
xminutes = prefManager.getCharPref("extensions.FinanceToolbar.xminutes");
excludedstock = prefManager.getCharPref("extensions.FinanceToolbar.excludedstock");
favoritestock = prefManager.getBoolPref("extensions.FinanceToolbar.favoritestock");
favo1 = prefManager.getCharPref("extensions.FinanceToolbar.favo1");
favo2 = prefManager.getCharPref("extensions.FinanceToolbar.favo2");
favo3 = prefManager.getCharPref("extensions.FinanceToolbar.favo3");
favo4 = prefManager.getCharPref("extensions.FinanceToolbar.favo4");
getinfovaluestock = prefManager.getBoolPref("extensions.FinanceToolbar.getinfovaluestock");
getinfovaluepercent = prefManager.getBoolPref("extensions.FinanceToolbar.getinfovaluepercent");
getinfovaluemc = prefManager.getBoolPref("extensions.FinanceToolbar.getinfovaluemc");

var element = "Change";
var ask = "Ask";
if(getinfovaluestock == true){element = "Change";}
else if(getinfovaluepercent == true){element = "ChangeinPercent";}
else if(getinfovaluemc == true){element = "MarketCapitalization";}

// create marquee
	    var newframe = document.createElement("div");
	    newframe.setAttribute('id','stefanvdfinance');
		document.body.insertBefore(newframe, document.body.firstChild);
	
	    var newworld = document.createElement("div");
	    newworld.setAttribute('class','stefanvdfinanceworld');
		newworld.addEventListener("click", function() { playSound(); });
		newframe.appendChild(newworld);

	    var newsoundframe = document.createElement("span");
	    newsoundframe.setAttribute('id','stefanvdfinancesound');
		newworld.appendChild(newsoundframe);
		
		function playSound() {
		var stefanvdfinancesound = document.getElementById("stefanvdfinancesound");
		var audioelement = document.createElement('audio');
		audioelement.setAttribute('src','chrome://FinanceToolbar/content/wallstreetbell.ogg');
		audioelement.setAttribute('hidden','true');
		audioelement.setAttribute('autoplay','true');
		stefanvdfinancesound.appendChild(audioelement);
		}		

		if(favoritestock == true){
		var newstockfavo = document.createElement("div");
		newstockfavo.setAttribute('id','stefanvdfinancefavo');
		newframe.appendChild(newstockfavo);	
		
			
		var newstockfavo1text = document.createTextNode(favo1);
		newstockfavo.appendChild(newstockfavo1text);
		var newstockfavo1img = document.createElement('img');
		newstockfavo1img.setAttribute('src','http://ichart.finance.yahoo.com/h?s=' + favo1 + '');
		newstockfavo1img.setAttribute('alt',favo1);
		newstockfavo1img.setAttribute('border','0');
		newstockfavo1img.setAttribute('height','15px');
		newstockfavo.appendChild(newstockfavo1img);
		var newstockfavo2text = document.createTextNode(favo2);
		newstockfavo.appendChild(newstockfavo2text);
		var newstockfavo2img = document.createElement('img');
		newstockfavo2img.setAttribute('src','http://ichart.finance.yahoo.com/h?s=' + favo2 + '');
		newstockfavo2img.setAttribute('alt',favo1);
		newstockfavo2img.setAttribute('border','0');
		newstockfavo2img.setAttribute('height','15px');
		newstockfavo.appendChild(newstockfavo2img);
		var newstockfavo3text = document.createTextNode(favo3);
		newstockfavo.appendChild(newstockfavo3text);
		var newstockfavo3img = document.createElement('img');
		newstockfavo3img.setAttribute('src','http://ichart.finance.yahoo.com/h?s=' + favo3 + '');
		newstockfavo3img.setAttribute('alt',favo1);
		newstockfavo3img.setAttribute('border','0');
		newstockfavo3img.setAttribute('height','15px');
		newstockfavo.appendChild(newstockfavo3img);
		var newstockfavo4text = document.createTextNode(favo4);
		newstockfavo.appendChild(newstockfavo4text);
		var newstockfavo4img = document.createElement('img');
		newstockfavo4img.setAttribute('src','http://ichart.finance.yahoo.com/h?s=' + favo4 + '');
		newstockfavo4img.setAttribute('alt',favo1);
		newstockfavo4img.setAttribute('border','0');
		newstockfavo4img.setAttribute('height','15px');
		newstockfavo.appendChild(newstockfavo4img);
		}

	    var newspeedleft = document.createElement("div");
	    newspeedleft.setAttribute('class','arrowleft');
		if(favoritestock == true){
		newspeedleft.style.left = "310px";
		} else {
		newspeedleft.style.left = "75px";
		}
		newspeedleft.textContent = "<";
		newspeedleft.addEventListener("mousedown", function() { document.getElementById("stefanvdfinancemarquee").setAttribute('direction', "left"); document.getElementById("stefanvdfinancemarquee").setAttribute('scrollamount', 50); });
		newspeedleft.addEventListener("mouseup", function() { document.getElementById("stefanvdfinancemarquee").setAttribute('direction', direction); document.getElementById("stefanvdfinancemarquee").setAttribute('scrollamount', scrollamount); });		
		newframe.appendChild(newspeedleft);
		
	    var newfinframe = document.createElement("marquee");
	    newfinframe.setAttribute('id', "stefanvdfinancemarquee");
	    newfinframe.setAttribute('behavior', marqueebehaviour);
	    newfinframe.setAttribute('direction', direction);
	    newfinframe.setAttribute('scrollamount', scrollamount);
		if(favoritestock == true){
		newfinframe.style.marginLeft = "332px";
		} else{
		newfinframe.style.marginLeft = "96px";
		}
		newfinframe.style.marginRight = "21px";
		newfinframe.addEventListener("mouseover", function() { document.getElementById("stefanvdfinancemarquee").setAttribute('scrollamount', 0);}, false);
		newfinframe.addEventListener("mouseout", function() { document.getElementById("stefanvdfinancemarquee").setAttribute('scrollamount', scrollamount);}, false);
		newframe.appendChild(newfinframe);
		
	    var newspeedright = document.createElement("div");
	    newspeedright.setAttribute('class','arrowright');
	    newspeedright.style.right = "0px";
		newspeedright.textContent = ">";
		newspeedright.addEventListener("mousedown", function() { document.getElementById("stefanvdfinancemarquee").setAttribute('direction', "right"); document.getElementById("stefanvdfinancemarquee").setAttribute('scrollamount', 50); }, false);
		newspeedright.addEventListener("mouseup", function() { document.getElementById("stefanvdfinancemarquee").setAttribute('direction', direction); document.getElementById("stefanvdfinancemarquee").setAttribute('scrollamount', scrollamount); }, false);
		newframe.appendChild(newspeedright);
		
		var newfinitembox = null;
		var newfinitem = null;
		var newfinitemask = null;

if(typeof excludedstock == "string") {
	excludedstock = JSON.parse(excludedstock);
	var buf = [];
	for(var domain in excludedstock)
		buf.push(domain);
        buf.sort();
	for(var i = 0; i < buf.length; i++) {
		// box
		    newfinitembox = document.createElement("div");
			newfinframe.appendChild(newfinitembox);			
			var newfinitemboxa = document.createElement('a');
			newfinitemboxa.setAttribute('href','http://finance.yahoo.com/q?s=' + encodeURIComponent(buf[i]) + '');
			newfinitemboxa.setAttribute('target','blank');
			newfinitembox.appendChild(newfinitemboxa);			
				var newfinitemboxatext = document.createTextNode(buf[i]);
				newfinitemboxa.appendChild(newfinitemboxatext);
		// span	
		    newfinitemask = document.createElement("span");
			newfinitemask.setAttribute('id',buf[i] + ask);
			newfinitembox.appendChild(newfinitemask);			
		// span
		    newfinitem = document.createElement("span");
			newfinitem.setAttribute('id',buf[i] + element);
			newfinitembox.appendChild(newfinitem);
			getinformation(buf[i], element, ask);
	}
}		

function getinformation(company, element, ask){
var a = company;
var b = element;
var c = ask;

var atext = "";
var ctext = "";

stockupdaterequest();
function stockupdaterequest() {
var reqversion = new XMLHttpRequest();
reqversion.onreadystatechange = function() {
	if(reqversion.readyState == 4) {
		if(reqversion.status == 200) {
				var downloadcloudversion = reqversion.responseXML;
				var x=downloadcloudversion.getElementsByTagName("quote");
	
				for (i=0;i<x.length;i++)
				{
				try {
				ctext =(x[i].getElementsByTagName(""+c+"")[0].childNodes[0].nodeValue);
				var tempac = document.getElementById(""+a+c+"");
					var tempaclink = document.createElement('a');
					tempaclink.setAttribute('href','http://finance.yahoo.com/q?s=' + encodeURIComponent(a) + '');
					tempaclink.setAttribute('target','blank');
					tempac.appendChild(tempaclink);			
						var tempaclinktext = document.createTextNode(ctext);
						tempaclink.appendChild(tempaclinktext);
				} catch(err){}
				try {
				atext =(x[i].getElementsByTagName(""+b+"")[0].childNodes[0].nodeValue);
				var tempab = document.getElementById(""+a+b+"");
					var tempablink = document.createElement('a');
					tempablink.setAttribute('href','http://finance.yahoo.com/q?s=' + encodeURIComponent(a) + '');
					tempablink.setAttribute('target','blank');
					tempab.appendChild(tempablink);			
						var tempablinktext = document.createTextNode(atext);
						tempablink.appendChild(tempablinktext);							
				} catch(err){}
				
				
				if(japan == true){
				// give color span
				// red
				if(atext.substring(0, 1) == '-') { document.getElementById(""+a+b+"").className = "green"; }
				// green
				else if(atext.substring(0, 1) == '+') { document.getElementById(""+a+b+"").className = "red"; }
				// white
				else { document.getElementById(""+a+b+"").className = "white"; }
				}
				else {
				// give color span
				// red
				if(atext.substring(0, 1) == '-') { document.getElementById(""+a+b+"").className = "red"; }
				// green
				else if(atext.substring(0, 1) == '+') { document.getElementById(""+a+b+"").className = "green"; }
				// white
				else { document.getElementById(""+a+b+"").className = "white"; }
				}
				
				}	
				
		}
	}
}
try {
reqversion.open("GET","https://query.yahooapis.com/v1/public/yql?q=select%20*%20from%20yahoo.finance.quotes%20where%20symbol%20in%20(%22"+a+"%22)&env=store://datatables.org/alltableswithkeys", true);
reqversion.send(null);
} catch(err){}
}

// Reload stock information every X minutes, which will trigger the autoupdate
// if stay on the same page
setInterval(stockupdaterequest, xminutes * 60 * 1000);

}


});