//================================================
/*

Finance Toolbar
This show you the real time stock market information.
Copyright (C) 2012 Stefan vd - All Rights Reserved.
www.stefanvd.net

*/
//================================================

function $(id) { return document.getElementById(id); }

// Firefox read pref
var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

// Option to save current value to window.localStorage
function save_options(){
	var e = $("marqueebehaviour"); prefManager.setCharPref("extensions.FinanceToolbar.marqueebehaviour", e.options[e.selectedIndex].value);
	var e = $("direction"); prefManager.setCharPref("extensions.FinanceToolbar.direction", e.options[e.selectedIndex].value);
	prefManager.setCharPref("extensions.FinanceToolbar.scrollamount", $('scrollamount').value);
	if($('japan').checked) prefManager.setBoolPref("extensions.FinanceToolbar.japan", true);
	else prefManager.setBoolPref("extensions.FinanceToolbar.japan", false);
	prefManager.setCharPref("extensions.FinanceToolbar.xminutes", $('xminutes').value);
	if($('favoritestock').checked) prefManager.setBoolPref("extensions.FinanceToolbar.favoritestock", true);
	else prefManager.setBoolPref("extensions.FinanceToolbar.favoritestock", false);
	prefManager.setCharPref("extensions.FinanceToolbar.favo1", $('favo1').value);
	prefManager.setCharPref("extensions.FinanceToolbar.favo2", $('favo2').value);
	prefManager.setCharPref("extensions.FinanceToolbar.favo3", $('favo3').value);
	prefManager.setCharPref("extensions.FinanceToolbar.favo4", $('favo4').value);
	if($('getinfovaluestock').checked) prefManager.setBoolPref("extensions.FinanceToolbar.getinfovaluestock", true);
	else prefManager.setBoolPref("extensions.FinanceToolbar.getinfovaluestock", false);
	if($('getinfovaluepercent').checked) prefManager.setBoolPref("extensions.FinanceToolbar.getinfovaluepercent", true);
	else prefManager.setBoolPref("extensions.FinanceToolbar.getinfovaluepercent", false);
	if($('getinfovaluemc').checked) prefManager.setBoolPref("extensions.FinanceToolbar.getinfovaluemc", true);
	else prefManager.setBoolPref("extensions.FinanceToolbar.getinfovaluemc", false);
	
// Excluded domains
var excludedstockBox = document.getElementById("excludedstockBox");
var excludedstock = {};
for (var i = 0; i < excludedstockBox.length; i++)
	excludedstock[excludedstockBox.options[i].value] = true;
	prefManager.setCharPref("extensions.FinanceToolbar.excludedstock", JSON.stringify(excludedstock));
}

function read_options(){
	if(prefManager.getCharPref("extensions.FinanceToolbar.marqueebehaviour"))$('marqueebehaviour').value = prefManager.getCharPref("extensions.FinanceToolbar.marqueebehaviour");
	else $('marqueebehaviour').value = "scroll";
	if(prefManager.getCharPref("extensions.FinanceToolbar.direction")){$('direction').value = prefManager.getCharPref("extensions.FinanceToolbar.direction");}
	else {$('direction').value = 'left';}
	if(prefManager.getCharPref("extensions.FinanceToolbar.scrollamount")){$('scrollamount').value = prefManager.getCharPref("extensions.FinanceToolbar.scrollamount");}
	else {$('scrollamount').value = '4';}
	if(prefManager.getBoolPref("extensions.FinanceToolbar.japan") == true)$('japan').checked = true;	
	if(prefManager.getCharPref("extensions.FinanceToolbar.xminutes")){$('xminutes').value = prefManager.getCharPref("extensions.FinanceToolbar.xminutes");}
	else {$('xminutes').value = '15';}	
	if(prefManager.getBoolPref("extensions.FinanceToolbar.favoritestock") == true)$('favoritestock').checked = true;		
	if(prefManager.getCharPref("extensions.FinanceToolbar.favo1")){$('favo1').value = prefManager.getCharPref("extensions.FinanceToolbar.favo1");}
	else {$('favo1').value = 'EURUSD=X';}
	if(prefManager.getCharPref("extensions.FinanceToolbar.favo2")){$('favo2').value = prefManager.getCharPref("extensions.FinanceToolbar.favo2");}
	else {$('favo2').value = 'USDJPY=X';}
	if(prefManager.getCharPref("extensions.FinanceToolbar.favo3")){$('favo3').value = prefManager.getCharPref("extensions.FinanceToolbar.favo3");}
	else {$('favo3').value = 'GBPUSD=X';}	
	if(prefManager.getCharPref("extensions.FinanceToolbar.favo4")){$('favo4').value = prefManager.getCharPref("extensions.FinanceToolbar.favo4");}
	else {$('favo4').value = 'USDCAD=X';}	
	if(prefManager.getBoolPref("extensions.FinanceToolbar.getinfovaluestock") == true)$('getinfovaluestock').checked = true;
	if(prefManager.getBoolPref("extensions.FinanceToolbar.getinfovaluepercent") == true)$('getinfovaluepercent').checked = true;	
	if(prefManager.getBoolPref("extensions.FinanceToolbar.getinfovaluemc") == true)$('getinfovaluemc').checked = true;
	
	// load tab div
	var tabListItems = document.getElementById('navbar').childNodes;
	for ( var i = 0; i < tabListItems.length; i++ ) {
		if ( tabListItems[i].nodeName == 'LI' ) {
		var tabLink = getFirstChildWithTagName( tabListItems[i], 'A' );
		var id = getHash( tabLink.getAttribute('onclick') );
		tabLinks[id] = tabLink;
		contentDivs[id] = document.getElementById( id );
        }
    }
    
    // Assign onclick events to the tab links, and
    // highlight the first tab
    var i = 0;
 
    for ( var id in tabLinks ) {
    	tabLinks[id].onclick = showTab;
		tabLinks[id].onfocus = function() { this.blur() };
		if ( i == 0 ) tabLinks[id].className = 'navbar-item-selected';
		i++;
    }
    
    // Hide all content divs except the first
    var i = 0;
 
    for ( var id in contentDivs ) {
    	if ( i != 0 ) contentDivs[id].className = 'page hidden';
        i++;
    }

    // display version number
    function displayVersionNumber() {
	// Firefox 4 and later; Mozilla 2 and later
	try {
    Components.utils.import("resource://gre/modules/AddonManager.jsm");
    AddonManager.getAddonByID("financetoolbar@stefanvd.net", function(addon) {
		$("version_number").textContent = addon.version;
	})
	} catch (ex) {} // silently fail
    }
    displayVersionNumber();
	
// Excluded domains - sort these alphabetically
var excludedstock = prefManager.getCharPref("extensions.FinanceToolbar.excludedstock");
if(typeof excludedstock == "undefined")
excludedstock = JSON.stringify({'GOOG': true,'MSFT': true,'YHOO': true,'AAPL': true,'DOW': true,'Gold': true,'Oil': true,'QQQX': true,'EURUSD=X': true,'^BFX': true}); // default stocks
		
if(typeof excludedstock == "string") {
	excludedstock = JSON.parse(excludedstock);
	var buf = [];
	for(var domain in excludedstock)
		buf.push(domain);
        buf.sort();
	for(var i = 0; i < buf.length; i++)
		appendToListBox("excludedstockBox", buf[i]);
    }
}

// Add a filter string to the list box.
function appendToListBox(boxId, text) { var elt = document.createElement("option"); elt.text = text; elt.value = text; document.getElementById(boxId).add(elt, null); }

// tabel script
    var tabLinks = new Array();
    var contentDivs = new Array();
 
    function showTab() {
      var selectedId = getHash( this.getAttribute('onclick') );
 
      // Highlight the selected tab, and dim all others.
      // Also show the selected content div, and hide all others.
      for ( var id in contentDivs ) {
        if ( id == selectedId ) {
          tabLinks[id].className = 'navbar-item-selected';
          contentDivs[id].className = 'page';
        } else {
          tabLinks[id].className = 'navbar-item';
          contentDivs[id].className = 'page hidden';
        }
      }
 
      // Stop the browser following the link
      return false;
    }
 
    function getFirstChildWithTagName( element, tagName ) {
      for ( var i = 0; i < element.childNodes.length; i++ ) {
        if ( element.childNodes[i].nodeName == tagName ) return element.childNodes[i];
      }
    }
 
    function getHash( url ) {
      var hashPos = url.lastIndexOf ( '#' );
      return url.substring( hashPos + 1 );
    }

// whitelist eye domain
function addWhitelistDomain() {
    var domain = document.getElementById("websiteurl").value;
    appendToListBox("excludedstockBox", domain);
    save_options();
}

function removeSelectedExcludedDomain() {
    var excludedstockBox = document.getElementById("excludedstockBox");
    for (var i = excludedstockBox.length-1; i >= 0; i--) {
        if (excludedstockBox.options[i].selected)
            excludedstockBox.remove(i);
    }
    save_options();
}

function test(){
var favoritestock = document.getElementById("favoritestock"); // fix firefox
if(favoritestock.checked == true){
document.getElementById("favorite").style.display = "";
document.getElementById("stefanvdfinancemarquee").style.marginLeft = "332px";
document.getElementById("arrowleft").style.marginLeft = "315px";
var textf1 = document.getElementById('favo1').value;$('samplefavo1').textContent = textf1;document.getElementById('samplefavo1img').src = "http://ichart.finance.yahoo.com/h?s=" + textf1+ "";
var textf2 = document.getElementById('favo2').value;$('samplefavo2').textContent = textf2;document.getElementById('samplefavo2img').src = "http://ichart.finance.yahoo.com/h?s=" + textf2+ "";
var textf3 = document.getElementById('favo3').value;$('samplefavo3').textContent = textf3;document.getElementById('samplefavo3img').src = "http://ichart.finance.yahoo.com/h?s=" + textf3+ "";
var textf4 = document.getElementById('favo4').value;$('samplefavo4').textContent = textf4;document.getElementById('samplefavo4img').src = "http://ichart.finance.yahoo.com/h?s=" + textf4+ "";
} else {
document.getElementById("favorite").style.display = "none";
document.getElementById("stefanvdfinancemarquee").style.marginLeft = "100px";
document.getElementById("arrowleft").style.marginLeft = "83px";
}
}

// Current year
function yearnow() {
var today = new Date(); var y0 = today.getFullYear();$("yearnow").textContent = y0;
}


/* Option page body action */
// Read current value settings
window.addEventListener('load', function() {
read_options();
test();
yearnow();
// remove loading screen
$('loading').style.display = "none";
});

document.addEventListener('DOMContentLoaded', function () {
// Detect click / change to save the page and test it.
var inputs = document.querySelectorAll('input');
for (var i = 0; i < inputs.length; i++) {inputs[i].addEventListener('change', test);inputs[i].addEventListener('change', save_options);}
var select = document.querySelectorAll('select');
for (var i = 0; i < select.length; i++) {select[i].addEventListener('change', test);select[i].addEventListener('change', save_options);}

// Close yellow bar
$("managed-prefs-text-close").addEventListener('click', function() {$("managed-prefs-banner").style.display = "none";});

// left
var goleft = document.getElementById("arrowleft")
goleft.addEventListener("mousedown", function() { 
document.getElementById("stefanvdfinancemarquee").setAttribute('direction', "left");
document.getElementById("stefanvdfinancemarquee").setAttribute('scrollamount', 50);
});

goleft.addEventListener("mouseup", function() {
var etempl = $("direction");var currentdirection = etempl.options[etempl.selectedIndex].value;
document.getElementById("stefanvdfinancemarquee").setAttribute('direction', currentdirection);
var currentamaount = document.getElementById("scrollamount").innerText; 
document.getElementById("stefanvdfinancemarquee").setAttribute('scrollamount', currentamaount);
});

// right
var goright = document.getElementById("arrowright")
goright.addEventListener("mousedown", function() { 
document.getElementById("stefanvdfinancemarquee").setAttribute('direction', "right");
document.getElementById("stefanvdfinancemarquee").setAttribute('scrollamount', 50);
});

goright.addEventListener("mouseup", function() {
var etempr = $("direction");var currentdirection = etempr.options[etempr.selectedIndex].value;
document.getElementById("stefanvdfinancemarquee").setAttribute('direction', currentdirection);
var currentamaount = document.getElementById("scrollamount").innerText; 
document.getElementById("stefanvdfinancemarquee").setAttribute('scrollamount', currentamaount);
});

// stop
var gostop = document.getElementById("stefanvdfinancemarquee")
gostop.addEventListener("mouseover", function() { 
document.getElementById("stefanvdfinancemarquee").setAttribute('scrollamount', 0);
});

gostop.addEventListener("mouseout", function() {
document.getElementById("stefanvdfinancemarquee").setAttribute('scrollamount', 4);
});	

// Add website
$("addbutton").addEventListener('click', function() {addWhitelistDomain();});

// Remove website
$("removebutton").addEventListener('click', function() {removeSelectedExcludedDomain();});

// Save KB download
$("tabbasic").addEventListener('click', function() {$('welcomeguide').src = "";});
$("tabdesign").addEventListener('click', function() {$('welcomeguide').src = "";});
$("tabguide").addEventListener('click', function() {$('welcomeguide').src = "http://www.stefanvd.net/project/financetoolbarfirefoxguide.htm";$("managed-prefs-banner").style.display = "none";});

});